﻿/*
This file is part of My Nes
A Nintendo Entertainment System Emulator.

 Copyright © 2009 - 2010 Ala Hadid (AHD)

My Nes is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

My Nes is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace MyNes
{
    public partial class Frm_ControlsSettings : Form
    {
        bool _Ok = false;
        public bool OK
        { get { return _Ok; } set { _Ok = value; } }
        public Frm_ControlsSettings()
        {
            InitializeComponent();
            //Load settings
            Player1_A.Text = Program.Settings.Player1_A;
            Player1_B.Text = Program.Settings.Player1_B;
            Player1_Up.Text = Program.Settings.Player1_Up;
            Player1_Left.Text = Program.Settings.Player1_Left;
            Player1_Right.Text = Program.Settings.Player1_Right;
            Player1_Down.Text = Program.Settings.Player1_Down;
            Player1_Select.Text = Program.Settings.Player1_Select;
            Player1_Start.Text = Program.Settings.Player1_Start;

            Player2_A.Text = Program.Settings.Player2_A;
            Player2_B.Text = Program.Settings.Player2_B;
            Player2_Up.Text = Program.Settings.Player2_Up;
            Player2_Left.Text = Program.Settings.Player2_Left;
            Player2_Right.Text = Program.Settings.Player2_Right;
            Player2_Down.Text = Program.Settings.Player2_Down;
            Player2_Select.Text = Program.Settings.Player2_Select;
            Player2_Start.Text = Program.Settings.Player2_Start;
        }
        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        private void button1_Click(object sender, EventArgs e)
        {
            //Save the settings
            Program.Settings.Player1_A = Player1_A.Text;
            Program.Settings.Player1_B = Player1_B.Text;
            Program.Settings.Player1_Up = Player1_Up.Text;
            Program.Settings.Player1_Left = Player1_Left.Text;
            Program.Settings.Player1_Right = Player1_Right.Text;
            Program.Settings.Player1_Down = Player1_Down.Text;
            Program.Settings.Player1_Select = Player1_Select.Text;
            Program.Settings.Player1_Start = Player1_Start.Text;

            Program.Settings.Player2_A = Player2_A.Text;
            Program.Settings.Player2_B = Player2_B.Text;
            Program.Settings.Player2_Up = Player2_Up.Text;
            Program.Settings.Player2_Left = Player2_Left.Text;
            Program.Settings.Player2_Right = Player2_Right.Text;
            Program.Settings.Player2_Down = Player2_Down.Text;
            Program.Settings.Player2_Select = Player2_Select.Text;
            Program.Settings.Player2_Start = Player2_Start.Text;

            Program.Settings.Save();
            _Ok = true;
            this.Close();
        }

        private void Player1_Left_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player1 Left");
            kk.ShowDialog();
            if (kk.OK)
            { Player1_Left.Text = kk.InputName; }
        }
        private void Player1_Right_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player1 Right");
            kk.ShowDialog();
            if (kk.OK)
            { Player1_Right.Text = kk.InputName; }
        }
        private void Player1_Up_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player1 Up");
            kk.ShowDialog();
            if (kk.OK)
            { Player1_Up.Text = kk.InputName; }
        }
        private void Player1_Down_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player1 Down");
            kk.ShowDialog();
            if (kk.OK)
            { Player1_Down.Text = kk.InputName; }
        }
        private void Player1_A_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player1 A");
            kk.ShowDialog();
            if (kk.OK)
            { Player1_A.Text = kk.InputName; }
        }
        private void Player1_B_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player1 B");
            kk.ShowDialog();
            if (kk.OK)
            { Player1_B.Text = kk.InputName; }
        }
        private void Player1_Start_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player1 Start");
            kk.ShowDialog();
            if (kk.OK)
            { Player1_Start.Text = kk.InputName; }
        }
        private void Player1_Select_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player1 Select");
            kk.ShowDialog();
            if (kk.OK)
            { Player1_Select.Text = kk.InputName; }
        }

        private void Player2_Left_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player2 Left");
            kk.ShowDialog();
            if (kk.OK)
            { Player2_Left.Text = kk.InputName; }
        }
        private void Player2_Right_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player2 Right");
            kk.ShowDialog();
            if (kk.OK)
            { Player2_Right.Text = kk.InputName; }
        }
        private void Player2_Up_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player2 Up");
            kk.ShowDialog();
            if (kk.OK)
            { Player2_Up.Text = kk.InputName; }
        }
        private void Player2_Down_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player2 Down");
            kk.ShowDialog();
            if (kk.OK)
            { Player2_Down.Text = kk.InputName; }
        }
        private void Player2_A_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player2 A");
            kk.ShowDialog();
            if (kk.OK)
            { Player2_A.Text = kk.InputName; }
        }
        private void Player2_B_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player2 B");
            kk.ShowDialog();
            if (kk.OK)
            { Player2_B.Text = kk.InputName; }
        }
        private void Player2_Start_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player2 Start");
            kk.ShowDialog();
            if (kk.OK)
            { Player2_Start.Text = kk.InputName; }
        }
        private void Player2_Select_Click(object sender, EventArgs e)
        {
            Frm_Key kk = new Frm_Key("Player2 Select");
            kk.ShowDialog();
            if (kk.OK)
            { Player2_Select.Text = kk.InputName; }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Player1_A.Text = "Keyboard.X";
            Player1_B.Text = "Keyboard.Z";
            Player1_Up.Text = "Keyboard.UpArrow";
            Player1_Left.Text = "Keyboard.LeftArrow";
            Player1_Right.Text = "Keyboard.RightArrow";
            Player1_Down.Text = "Keyboard.DownArrow";
            Player1_Select.Text = "Keyboard.C";
            Player1_Start.Text = "Keyboard.V";

            Player2_A.Text = "Keyboard.K";
            Player2_B.Text = "Keyboard.J";
            Player2_Up.Text = "Keyboard.W";
            Player2_Left.Text = "Keyboard.A";
            Player2_Right.Text = "Keyboard.D";
            Player2_Down.Text = "Keyboard.S";
            Player2_Select.Text = "Keyboard.Q";
            Player2_Start.Text = "Keyboard.E";
        }
    }
}
